<?php

namespace Slovocast\Infrastructure\Api\Database;

use PDO;

interface DatabaseHandlerInterface 
{
    public function getConnection(): PDO;

    /**
     * Get the connection string required for establishing connections to the
     * database
     */
    public function getDsn(): string;

    /**
     * @param string $query
     * @param array $params Either a list of params of the KV params
     * @return array The results as an array, empty if no results
     */
    public function query(string $query, array $params = []): array;

    /**
     * @param string $query
     * @param array $params Either a list of params, or the KV of params
     * @return bool True if successful
     */
    public function insert(string $query, array $params = []): bool;
}
